#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <iterator>

using namespace std;


class kosar
	{
	public:
		map<string, int> aru;

		int darab()
			{
			int db = 0;
			map<string, int>::iterator a;
			for ( a = aru.begin(); a != aru.end(); ++a) db += a->second;
			return db;
			}

		int kosarertek()
			{
			int szum = 0;
			for (map<string, int>::iterator it = aru.begin(); it != aru.end(); ++it)
				szum += (it->second == 1 ? 100 : 150) + it->second * 400;
			return szum;
			}
	};

vector<kosar> kosarak;

void beolvas()
	{
	ifstream fin;
	fin.open("penztar.txt");
	string sor;
	kosar aktKosar;
	while(getline(fin, sor) != 0) {
			if (sor == "F") {
					kosarak.push_back(aktKosar);
					aktKosar.aru.clear();
					//kiurites helyett uj kosar:
					//kosar aktKosar;
					}
			else {
					aktKosar.aru[sor]++;
					}
			}
	fin.close();
	}

int ertek(int db)
	{
	return (db == 1 ? 100 : 150) + db * 400;
	}

void kiiras()
	{
	ofstream fout;
	fout.open("osszeg.txt");
	for (size_t i = 0; i < kosarak.size(); ++i)
		fout << i + 1 << ": " << kosarak[i].kosarertek() << "\n";
	fout.close();
	}

int main()
	{
	beolvas();

	cout << "\n2. feladat\n";
	cout << "A fizetesek szama: " << kosarak.size() << "\n";

	cout << "\n3. feladat\n";
	cout << "Az elso vasarlo " << kosarak[0].darab() << " darab arucikket vasarolt\n";

	cout << "\n4. feladat\n";
	int sorszam;
	cout << "Adja meg egy vasarlas sorszamat! ";
	cin >> sorszam;
	string cikk;
	cout << "Adja meg egy arucikk nevet! ";
	cin >> cikk;
	int db;
	cout << "Adja meg a vasarolt darabszamot! ";
	cin >> db;

	cout << "\n5. feladat\n";
	int elso = -1, utolso = -1, osszes = 0;
	for (size_t i = 0; i < kosarak.size(); ++i) {
			if (kosarak[i].aru.find(cikk) != kosarak[i].aru.end()) {
					if(elso == -1) elso = i;
					utolso = i;
					osszes++;
					}
			}
	cout << "Az elso vasarlas sorszama: " << elso + 1 << "\n";
	cout << "Az utolso vasarlas sorszama: " << utolso + 1 << "\n";
	cout << osszes << " vasarlas soran vettek belole.\n";

	cout << "\n6. feladat\n";
	cout << db << " darab vetelekor fizetendo: " << ertek(db) << "\n";

	cout << "\n7. feladat\n";
	for (map<string, int>::iterator it = kosarak[sorszam - 1].aru.begin(); it != kosarak[sorszam - 1].aru.end(); ++it)
		cout << it->second << " " << it->first << "\n";
	cout << "\n8. feladat\n";
	kiiras();


	return 0;
	}
